com.smartgwt.client.widgets.form.fields

## Class DateRangeItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.CanvasItem
          - - com.smartgwt.client.widgets.form.fields.DateRangeItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasCanEditChangedHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPendingStatusChangedHandlers, HasPickerIconClickHandlers, HasReadOnlyDisplayChangedHandlers, HasShowValueHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers, HasValueIconClickHandlers

      public class DateRangeItem
      extends CanvasItem

  Allows a user to select an absolute or relative range of dates via two `RelativeDateItem`s (if `allowRelativeDates` is true) or two `DateItems`.

  The item's `data type` is expected to be one of "date" or "datetime" and dictates whether the dates in the range include a time portion. If unset and the item's form is databound, the data type is detected from the associated `dataSource field`. If there is no such field, or the form is not databound, the default data type value is "date".

  DateRangeItem is just a convenience relative to using two `RelativeDateItem` or `DateItem` controls in a form, then using `FormItem.operator` and `FormItem.criteriaField` to cause them to produce a date range. If you need more control over layout, validation, event handling or any other aspect of appearance or behavior, stop using DateRangeItem and use two DateItem/RelativeDateItem controls directly instead.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `FormItem.CustomStateGetter, FormItem.StateCustomizer`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `scClassName, warnOnEditorTypeConversion, warnOnEditorTypeConversionDefault`

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.DataClass

      `factoryCreated, factoryProperties, readOnly`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DateRangeItem()`
    `DateRangeItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `DateRangeItem(java.lang.String name)`
    `DateRangeItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, DrawItem defaults)` Changes the defaults for DrawItem AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `java.lang.String` | `getAbsoluteDateTimeItemConstructor()` The `FormItem` class to create when `allowRelativeDates` is false, and the `DateRangeItem`'s type is "datetime".
    `java.lang.String` | `getAbsoluteItemConstructor()` The `FormItem` class to create when `allowRelativeDates` is false, but the `DateRangeItem` does not have type "datetime".
    `java.lang.Boolean` | `getAllowRelativeDates()` Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
    `DynamicForm` | `getDateRangeForm()` `DynamicForm` `com.smartgwt.client.types.AutoChild` automatically created by the dateRangeItem and applied to the item as `this.canvas`.
    `DateFieldLayout` | `getFieldLayout()` Controls the placement of the `toField` and `fromField` in the `dateRangeForm`.
    `java.util.Date` | `getFromDate()` Initial value for the "from" date.
    `FormItem` | `getFromField()` The field for the "from" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.
    `java.lang.String` | `getFromTitle()` The title for the `from` part of the range.
    `TitleOrientation` | `getInnerTitleOrientation()` The title orientation for the to / from sub-items.
    `java.lang.String` | `getInputFormat()` For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
    `java.lang.String` | `getInvalidRangeErrorMessage()` Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
    `static DateRangeItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.String` | `getRelativeItemConstructor()` The `FormItem` class to create when `allowRelativeDates` is true.
    `java.lang.Boolean` | `getShouldSaveValue()` Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
    `java.util.Date` | `getToDate()` Initial value for the "to" date.
    `java.lang.String` | `getToDateAsString()` Initial value for the "to" date.
    `TimeUnit` | `getToDateAsTimeUnit()` Initial value for the "to" date.
    `FormItem` | `getToField()` The field for the "to" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.
    `java.lang.String` | `getToTitle()` The title for the `to` part of the range.
    `java.lang.Boolean` | `getValidateCriteria()` If this attribute is set to `true` when `getCriteria()` is called, the item will validate the "to" and "from" fields and return null if either field fails validation.
    `DateRange` | `getValue()` Retrieves the current value of this dateRangeItem.
    `java.lang.Boolean` | `hasAdvancedCriteria()` Overridden to return true: dateRangeItems always generate AdvancedCriteria.
    `void` | `setAllowRelativeDates(java.lang.Boolean allowRelativeDates)` Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
    `void` | `setCanEditCriterionPredicate(FormItemCanEditCriterionPredicate predicate)` The default `canEditCriterion()` predicate returns true if the specified criterion contains: A single "lessOrEqual" or "greaterOrEqual" criterion on this field An "and" type criterion containing a "lessOrEqual" and a "greaterOrEqual" criterion on this field A single "equals" criterion.
    `void` | `setCriterionSetter(FormItemCriterionSetter setter)` The default `setCriterion()` implementation applies the specified criterion to this item for editing.
    `static void` | `setDefaultProperties(DateRangeItem dateRangeItemProperties)` Class level method to set the default properties of this class.
    `void` | `setFieldLayout(DateFieldLayout fieldLayout)` Controls the placement of the `toField` and `fromField` in the `dateRangeForm`.
    `void` | `setFromDate(java.util.Date fromDate)` Initial value for the "from" date.
    `void` | `setFromTitle(java.lang.String fromTitle)` The title for the `from` part of the range.
    `void` | `setInnerTitleOrientation(TitleOrientation innerTitleOrientation)` The title orientation for the to / from sub-items.
    `void` | `setInputFormat(java.lang.String inputFormat)` For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
    `void` | `setInvalidRangeErrorMessage(java.lang.String invalidRangeErrorMessage)` Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
    `void` | `setShouldSaveValue(java.lang.Boolean shouldSaveValue)` Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
    `void` | `setToDate(java.util.Date toDate)` Initial value for the "to" date.
    `void` | `setToDate(java.lang.String toDate)` Initial value for the "to" date.
    `void` | `setToDate(TimeUnit toDate)` Initial value for the "to" date.
    `void` | `setToTitle(java.lang.String toTitle)` The title for the `to` part of the range.
    `void` | `setValidateCriteria(java.lang.Boolean validateCriteria)` If this attribute is set to `true` when `getCriteria()` is called, the item will validate the "to" and "from" fields and return null if either field fails validation.
    `void` | `setValue(DateRange value)` Sets the value for this dateRangeItem.
    `java.lang.Boolean` | `validateRange()` Validate both "to" and "from" date-fields.

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.CanvasItem

      `addCanEditChangedHandler, addReadOnlyDisplayChangedHandler, addShowValueHandler, createCanvas, getApplyPromptToCanvas, getAutoDestroy, getCanvas, getEditCriteriaInInnerForm, getHeight, getHeightAsString, getMultiple, getOverflow, getPrompt, isFocused, setApplyPromptToCanvas, setAutoDestroy, setCanvas, setCriterionGetter, setDefaultProperties, setEditCriteriaInInnerForm, setHeight, setHeight, setMultiple, setOverflow, setPrompt, setShouldDisableCanvasCustomizer, setupCanvasConstructor, storeValue, storeValue, storeValue`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPendingStatusChangedHandler, addPickerIconClickHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, addValueIconClickHandler, asSGWTComponent, blurItem, canEditCriterion, clearErrors, clearValue, disable, disableIcon, enable, enableIcon, error, error, errorIfNotCreated, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getApplyAlignToText, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsObject, getAttributeAsString, getAutoComplete, getBrowserInputType, getBrowserSpellCheck, getCanEdit, getCanEditOpaqueValues, getCanFocus, getCanSelectText, getCanvasAutoChild, getCellHeight, getCellStyle, getChangeOnKeypress, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getControlStyle, getCriteriaField, getCriterion, getCriterion, getCursorPosition, getCustomState, getDataPath, getDateFormatter, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEditProxyConstructor, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getErrors, getExportFormat, getFetchMissingValues, getFieldName, getFilterLocally, getForeignDisplayField, getForm, getFormat, getFormItemAutoChild, getFullDataPath, getGlobalTabIndex, getGridColNum, getGridRowNum, getHidden, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIconVAlign, getIconWidth, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getLeft, getLoadingDisplayValue, getLocateItemBy, getMultipleValueSeparator, getName, getOperator, getOptionCriteria, getOptionFilterContext, getOptionOperationId, getOriginalValueMessage, getPageLeft, getPageRect, getPageTop, getPicker, getPickerIconHeight, getPickerIconName, getPickerIconPrompt, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconWidth, getPixelHeight, getPixelWidth, getPrintTextBoxStyle, getPrintTitleStyle, getReadOnlyDisplay, getReadOnlyHover, getReadOnlyTextBoxStyle, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRowSpan, getSaveOnEnter, getScClassName, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDeletions, getShowDisabled, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowOldValueInHover, getShowOverIcons, getShowPending, getShowPickerIcon, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStaticHeight, getStopOnError, getSupportsCutPasteEvents, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTextBoxStyle, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getUseDisabledHintStyleForReadOnly, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValueAsRecordList, getValueDeselectedCSSText, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getVisible, getVisibleHeight, getVisibleTitleWidth, getVisibleWidth, getWarnOnEditorTypeConversion, getWarnOnEditorTypeConversionDefault, getWidth, getWidthAsString, getWrapTitle, handleWarnOnEditorTypeConversion, hasErrors, hide, hideIcon, invalidateDisplayValueCache, isCreated, isCutEvent, isDisabled, isDrawn, isInGrid, isPasteEvent, isVisible, linkToInstanceUponCreate, mapDisplayToValue, mapValueToDisplay, mapValueToDisplay, mapValueToDisplay, redraw, redraw, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setApplyAlignToText, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoComplete, setBrowserInputType, setBrowserSpellCheck, setCanEdit, setCanEditOpaqueValues, setCanFocus, setCanSelectText, setCellHeight, setCellStyle, setChangeOnKeypress, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setControlStyle, setCriteriaField, setCriterion, setCustomStateGetter, setDataPath, setDateFormatter, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEditProxyConstructor, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setErrors, setErrors, setExportFormat, setFetchMissingValues, setFilterLocally, setForeignDisplayField, setFormat, setGlobalTabIndex, setHidden, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconDisabled, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconVAlign, setIconWidth, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setJavaScriptObject, setLeft, setLoadingDisplayValue, setLocateItemBy, setMultipleValueSeparator, setName, setNullProperty, setOperator, setOptionCriteria, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setOriginalValueMessage, setPickerIconHeight, setPickerIconName, setPickerIconPrompt, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyHover, setReadOnlyTextBoxStyle, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRowSpan, setSaveOnEnter, setScClassName, setSelectOnClick, setSelectOnFocus, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDeletions, setShowDisabled, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIfCondition, setShowOldValueInHover, setShowOverIcons, setShowPending, setShowPickerIcon, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStateCustomizer, setStaticHeight, setStopOnError, setSupportsCutPasteEvents, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTextBoxStyle, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setUseDisabledHintStyleForReadOnly, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueDeselectedCSSText, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setWarnOnEditorTypeConversion, setWarnOnEditorTypeConversionDefault, setWidth, setWidth, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, shouldStopKeyPressBubbling, show, showIcon, showPicker, stopHover, storeValue, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `applyFactoryProperties, doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, getReadOnly, isFactoryCreated, logConfiguration, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject, setFactoryCreated, setReadOnly`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, getJsObj, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DateRangeItem

          public DateRangeItem()

    - #### DateRangeItem

          public DateRangeItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### DateRangeItem

          public DateRangeItem(java.lang.String name)

    - #### DateRangeItem

          public DateRangeItem(java.lang.String name,
                               java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static DateRangeItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     DrawItem defaults)

      Changes the defaults for DrawItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - DrawItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### getAbsoluteDateTimeItemConstructor

          public java.lang.String getAbsoluteDateTimeItemConstructor()

      The `FormItem` class to create when `allowRelativeDates` is false, and the `DateRangeItem`'s type is "datetime".
      Returns:
        String
      See Also:
        `FieldType`

    - #### getAbsoluteItemConstructor

          public java.lang.String getAbsoluteItemConstructor()

      The `FormItem` class to create when `allowRelativeDates` is false, but the `DateRangeItem` does not have type "datetime".
      Returns:
        String
      See Also:
        `FieldType`

    - #### setAllowRelativeDates

          public void setAllowRelativeDates(java.lang.Boolean allowRelativeDates)

      Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
      Parameters:
        `allowRelativeDates` - Default value is false

    - #### getAllowRelativeDates

          public java.lang.Boolean getAllowRelativeDates()

      Whether to allow the user to specify relative dates (via `RelativeDateItem`s) or whether dates are absolute (via `DateItem`s).
      Returns:
        Boolean

    - #### getDateRangeForm

          public DynamicForm getDateRangeForm()

      `DynamicForm` `com.smartgwt.client.types.AutoChild` automatically created by the dateRangeItem and applied to the item as `this.canvas`.

      This DynamicForm contains the "from" and "to" fields the user will interact with to actually select a date-range. Note that as a standard autoChild, developers may customize this form by modifying `dateRangeProperties`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        DynamicForm

    - #### setFieldLayout

          public void setFieldLayout(DateFieldLayout fieldLayout)

      Controls the placement of the `toField` and `fromField` in the `dateRangeForm`.

      Note that we don't recommend "horizontal" placement for mobile, and we also don't recommend it for `allowRelativeDates` mode, since `RelativeDateItem` changes width drastically during editing, which causes a lot of unpleasant side-to-side shifting of controls.

      Parameters:
        `fieldLayout` - Default value is "vertical"

    - #### getFieldLayout

          public DateFieldLayout getFieldLayout()

      Controls the placement of the `toField` and `fromField` in the `dateRangeForm`.

      Note that we don't recommend "horizontal" placement for mobile, and we also don't recommend it for `allowRelativeDates` mode, since `RelativeDateItem` changes width drastically during editing, which causes a lot of unpleasant side-to-side shifting of controls.

      Returns:
        DateFieldLayout

    - #### getFromField

          public FormItem getFromField()

      The field for the "from" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        FormItem

    - #### setFromTitle

          public void setFromTitle(java.lang.String fromTitle)

      The title for the `from` part of the range.
      Parameters:
        `fromTitle` - Default value is "From"

    - #### getFromTitle

          public java.lang.String getFromTitle()

      The title for the `from` part of the range.
      Returns:
        String

    - #### setInnerTitleOrientation

          public void setInnerTitleOrientation(TitleOrientation innerTitleOrientation)

      The title orientation for the to / from sub-items. If unset this will be derived from `this.titleOrientation` or `this.form.titleOrientation`.
      Parameters:
        `innerTitleOrientation` - Default value is null

    - #### getInnerTitleOrientation

          public TitleOrientation getInnerTitleOrientation()

      The title orientation for the to / from sub-items. If unset this will be derived from `this.titleOrientation` or `this.form.titleOrientation`.
      Returns:
        TitleOrientation

    - #### setInputFormat

          public void setInputFormat(java.lang.String inputFormat)

      For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
      Overrides:
        `setInputFormat` in class `FormItem`
      Parameters:
        `inputFormat` - See `DateInputFormat` . Default value is null
      See Also:
        `FormItem.setDateFormatter(com.smartgwt.client.types.DateDisplayFormat)`

    - #### getInputFormat

          public java.lang.String getInputFormat()

      For fields of type `"date"`, if this is an editable field such as a `TextItem`, this property allows you to specify the `inputFormat` applied to the item.
      Overrides:
        `getInputFormat` in class `FormItem`
      Returns:
        See `DateInputFormat`
      See Also:
        `FormItem.getDateFormatter()`

    - #### setInvalidRangeErrorMessage

          public void setInvalidRangeErrorMessage(java.lang.String invalidRangeErrorMessage)

      Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
      Parameters:
        `invalidRangeErrorMessage` - Default value is '"To" field value cannot be earlier than "From" field value.'

    - #### getInvalidRangeErrorMessage

          public java.lang.String getInvalidRangeErrorMessage()

      Error message to display if the user enters a date range where the "To" field value is earlier than the "From" field value.
      Returns:
        String

    - #### getRelativeItemConstructor

          public java.lang.String getRelativeItemConstructor()

      The `FormItem` class to create when `allowRelativeDates` is true.
      Returns:
        String

    - #### setShouldSaveValue

          public void setShouldSaveValue(java.lang.Boolean shouldSaveValue)

      Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
      Overrides:
        `setShouldSaveValue` in class `CanvasItem`
      Parameters:
        `shouldSaveValue` - Default value is true

    - #### getShouldSaveValue

          public java.lang.Boolean getShouldSaveValue()

      Allow dateRangeItems' values to show up in the form's values array, or if `DynamicForm.getValuesAsCriteria()` is called, for the criterion to be included in the returned AdvancedCriteria object
      Overrides:
        `getShouldSaveValue` in class `CanvasItem`
      Returns:
        Boolean

    - #### setToDate

          public void setToDate(java.util.Date toDate)

      Initial value for the "to" date.
      If this method is called after the component has been drawn/initialized: Sets the `toDate` for this DateRangeItem.
      Parameters:
        `toDate` - the date at which this item should end it's range. Default value is today

    - #### getToDate

          public java.util.Date getToDate()

      Initial value for the "to" date.
      Returns:
        Date

    - #### setToDate

          public void setToDate(java.lang.String toDate)

      Initial value for the "to" date.
      If this method is called after the component has been drawn/initialized: Sets the `toDate` for this DateRangeItem.
      Parameters:
        `toDate` - the date at which this item should end it's range See `RelativeDateString` . Default value is today

    - #### getToDateAsString

          public java.lang.String getToDateAsString()

      Initial value for the "to" date.
      Returns:
        See `RelativeDateString`

    - #### setToDate

          public void setToDate(TimeUnit toDate)

      Initial value for the "to" date.
      If this method is called after the component has been drawn/initialized: Sets the `toDate` for this DateRangeItem.
      Parameters:
        `toDate` - the date at which this item should end it's range. Default value is today

    - #### getToDateAsTimeUnit

          public TimeUnit getToDateAsTimeUnit()

      Initial value for the "to" date.
      Returns:
        TimeUnit

    - #### getToField

          public FormItem getToField()

      The field for the "to" date - a `RelativeDateItem` or `DateItem` according to `allowRelativeDates`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        FormItem

    - #### setToTitle

          public void setToTitle(java.lang.String toTitle)

      The title for the `to` part of the range.
      Parameters:
        `toTitle` - Default value is "To"

    - #### getToTitle

          public java.lang.String getToTitle()

      The title for the `to` part of the range.
      Returns:
        String

    - #### setValidateCriteria

          public void setValidateCriteria(java.lang.Boolean validateCriteria)

      If this attribute is set to `true` when `getCriteria()` is called, the item will validate the "to" and "from" fields and return null if either field fails validation. See `validateRange()`
      Parameters:
        `validateCriteria` - Default value is false

    - #### getValidateCriteria

          public java.lang.Boolean getValidateCriteria()

      If this attribute is set to `true` when `getCriteria()` is called, the item will validate the "to" and "from" fields and return null if either field fails validation. See `validateRange()`
      Returns:
        Boolean

    - #### hasAdvancedCriteria

          public java.lang.Boolean hasAdvancedCriteria()

      Overridden to return true: dateRangeItems always generate AdvancedCriteria.
      Overrides:
        `hasAdvancedCriteria` in class `CanvasItem`
      Returns:
        true
      See Also:
        `CriteriaEditing overview and related methods`

    - #### validateRange

          public java.lang.Boolean validateRange()

      Validate both "to" and "from" date-fields.
      Returns:
        false if either to or from field contains an invalid date value.

    - #### setDefaultProperties

          public static void setDefaultProperties(DateRangeItem dateRangeItemProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties of the class instance passed to this function. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `dateRangeItemProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setFromDate

          public void setFromDate(java.util.Date fromDate)

      Initial value for the "from" date. Sets the `fromDate` for this DateRangeItem.
      Parameters:
        `fromDate` - the date from which this item should start it's range. Default value is today

    - #### getFromDate

          public java.util.Date getFromDate()

      Initial value for the "from" date.
      Returns:
        java.util.Date

    - #### getValue

          public DateRange getValue()

      Retrieves the current value of this dateRangeItem. The return value is a `DateRange` object that excludes start and end values if they aren't set.
      Overrides:
        `getValue` in class `FormItem`
      Returns:
        the current value of this item

    - #### setValue

          public void setValue(DateRange value)

      Sets the value for this dateRangeItem. The value parameter is a `DateRange` object that optionally includes both start and end values.
      Parameters:
        `value` - the new value for this item

    - #### setCanEditCriterionPredicate

          public void setCanEditCriterionPredicate(FormItemCanEditCriterionPredicate predicate)

      The default `canEditCriterion()` predicate returns true if the specified criterion contains:
      - A single "lessOrEqual" or "greaterOrEqual" criterion on this field
      - An "and" type criterion containing a "lessOrEqual" and a "greaterOrEqual" criterion on this field
      - A single "equals" criterion. Internally, this will be converted into a range by constructing an "and" type criterion containing both a "lessOrEqual" and a "greaterOrEqual" criterion on this field. Note that subsequent calls to the `FormItemCriterionGetter`'s `getCriterion()` method will return this more complex criterion.
      Overrides:
        `setCanEditCriterionPredicate` in class `CanvasItem`
      Parameters:
        `predicate` - the predicate to determine the form items that can edit the criterion in question
      See Also:
        `FormItem.setCanEditCriterionPredicate`, `CriteriaEditing overview and related methods`

    - #### setCriterionSetter

          public void setCriterionSetter(FormItemCriterionSetter setter)

      The default `setCriterion()` implementation applies the specified criterion to this item for editing. Applies any specified "greaterOrEqual" operator criterion or sub-criterion to our `fromField` and any specified "lessOrEqual" operator criterion or sub-criterion to our `toField`.

      Note that a single "equals" criterion can also be passed. See `setCanEditCriterionPredicate()` for more detail.

      Overrides:
        `setCriterionSetter` in class `CanvasItem`
      Parameters:
        `setter` - provides a method to update this field with the edited criterion